// ===== Modellierung ========== Wolfgang Erben

package studienarbeit;

import pflichtuebung1.korrekt.Intervall;

/**
 * Die Schnittstelle beschreibt ebene Kurven in Parameter-Darstellung. 
 * Das Parameter-Intervall ist [0,1]. Ausserhalb dieses Bereiches koennen
 * Methoden Fehler liefern. 
 * 
 * @author Wolfgang Erben
 * @version 1.2 23.05.2009
 */
public interface IKurve {
    
    Intervall INTERVALL = new Intervall(0., 1.);
    /**
     * liefert die x-Koordinate des Punktes zum angegebenen Parameter-Wert.
     */
    double x(double t);
    /**
     * liefert die y-Koordinate des Punktes zum angegebenen Parameter-Wert.
     */
    double y(double t);
    /**
     * liefert das Bild des angegebenen Intervalls durch die Funktion x(t),
     * also alle moeglichen x-Werte, wenn t das angegebene Intervall 
     * durchlaeuft. 
     * Es kann auch eine Obermenge hiervon zurueck gegeben werden, falls die
     * Berechnung des genauen Bildes zu schwierig ist. Es muss aber garantiert
     * sein, dass die Laenge des Intervalls gegen 0 geht, wenn dies die
     * Laenge des Urbildes tut. 
     * 
     */
    Intervall x(Intervall urbild);
    /**
     * liefert das Bild des angegebenen Intervalls durch die Funktion y(t),
     * also alle moeglichen y-Werte, wenn t das angegebene Intervall 
     * durchlaeuft.
     * Es kann auch eine Obermenge hiervon zurueck gegeben werden, falls die
     * Berechnung des genauen Bildes zu schwierig ist. Es muss aber garantiert
     * sein, dass die Laenge des Intervalls gegen 0 geht, wenn dies die
     * Laenge des Urbildes tut. 
     */
    Intervall y(Intervall urbild);
}