// ===== Modellierung ========== Wolfgang Erben

package pruefung2;

import pflichtuebung1.korrekt.Intervall;
import studienarbeit.*;

/**
 * stellt Hilfsmittel zur Behandlung von Kurven bereit. 
 * 
 * @author Wolfgang Erben
 * @version 1.0 03.06.2010
 */
public final class Kurven {
    public static final double MAX_KOORD = 10000.;
    private static final double HALBE = 1. / 2.;
    private Kurven() {
    }
    /**
     * liefert den zum angegebenen Paramterwert gehoerenden Punkt
     * auf der angegebenen Kurve.
     */
    public static Punkt kurvenPunkt(IKurve k, double t) {
        return new Punkt(k.x(t), k.y(t));
    }
    /**
     * liefert ein zufaelliges Teil-Intervall von (0,1].
     */
    public static Intervall zufaelligesIntervall() {
        double t1 = 1. - Math.random();
        double t2 = 1. - Math.random();
        if (t2 < t1) return new Intervall(t2, t1);
        return new Intervall(t1, t2);
    }
    /**
     * liefert eine zufaelligen, nicht-negativen Koordinaten-Wert.
     */
    public static double zufaelligePositiveKoordinate() {
        return Math.random() * Kurven.MAX_KOORD;
    }
    /**
     * liefert eine zufaelligen Koordinaten-Wert.
     */
    public static double zufaelligeKoordinate() {
        double wert = Math.random() * Kurven.MAX_KOORD;
        if (Math.random() < HALBE) return wert;
        return -wert;
    }
    /**
     * liefert einen zufaelligen Punkt.
     */
    public static Punkt zufaelligerPunkt() {
        double x = zufaelligeKoordinate();
        double y = zufaelligeKoordinate();
        return new Punkt(x, y);
    }
    

}
